<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { ref, computed } from 'vue';
import { Marked } from 'marked';
import { markedHighlight } from 'marked-highlight';
import hljs from 'highlight.js';
import { useI18n } from 'vue-i18n';
import katex from 'katex';
import 'katex/dist/katex.min.css';


const { t } = useI18n();
const $t = t;
const props = defineProps<{
    source: string,
    hideSourceCopyButton?: boolean,
    print?: boolean
}>();

const containerRef = ref<HTMLElement>();
defineExpose({
    containerRef
});

const marked = new Marked(
    markedHighlight({
        langPrefix: 'hljs language-',
        highlight(code, lang) {
            const language = hljs.getLanguage(lang) ? lang : 'plaintext';
            return hljs.highlight(code, { language }).value;
        }
    }),
);

const renderer = {
    code(code: { text: string }, infostring: string | undefined) {
        return `<div class="w-full select-none">
            <pre class="w-full">${code.text}</pre>
            <div class="flex flex-row gap-2 bg-gray-400 w-full max-w-[calc(100dvw-50%)] h-8 px-2 py-1 leading-6 align-middle text-gray-100 rounded-b-md">
                <div class="capitalize pl-2">${infostring || 'code'}</div>
                ${!props.hideSourceCopyButton ? `<button class="ml-auto copy-button hover:bg-gray-500 rounded-md px-2 flex flex-row gap-2"><i class="ri-clipboard-line"></i>${$t('ai.chat.option.copySourceCode.label')}</button>` : ''}
            </div>
        </div>`;
    }
};

const customLatexExtension = () => {
    return {
        extensions: [{
            name: 'customLatex',
            level: 'inline',
            start(src: string) { return src.match(/\\\(|\\\[/)?.index; },
            tokenizer(src: string) {
                const inlineRule = /^\\\((.+?)\\\)/;
                const blockRule = /^\\\[([\s\S]+?)\\\]/;
                const inlineMatch = inlineRule.exec(src);
                const blockMatch = blockRule.exec(src);
                if (inlineMatch) {
                    return {
                        type: 'customLatex',
                        raw: inlineMatch[0],
                        text: inlineMatch[1].trim(),
                        displayMode: false
                    };
                }
                if (blockMatch) {
                    return {
                        type: 'customLatex',
                        raw: blockMatch[0],
                        text: blockMatch[1].trim(),
                        displayMode: true
                    };
                }
            },
            renderer(token: any) {
                return katex.renderToString(token.text, {
                    displayMode: token.displayMode,
                    throwOnError: false
                });
            }
        }]
    };
}

const computedContent = computed(() => {
    const text = props.source;
    return marked.use({ renderer: renderer }, customLatexExtension()).parse(text);
});

</script>
<template>
    <div class="md break-words xl:max-w-full" :class="print?'print':''" ref="containerRef">
        <div v-html="computedContent"></div>
    </div>
</template>
<style>
.md>* ul {
    @apply list-disc ml-4
}

.md>* ol {
    @apply list-decimal ml-4
}

.md>* pre {
    @apply bg-gray-300 rounded-t-md p-2 w-full max-w-[calc(100dvw-50%)] overflow-auto block break-words
}

.md>* pre>code {
    @apply max-w-[50dvw] inline-block min-w-full
}

.md>* h1 {
    @apply text-2xl
}

.md>* h2 {
    @apply text-xl
}

.md>* h3 {
    @apply text-lg
}

.md>* p {
    @apply my-4 whitespace-pre-wrap
}


.md>* p:first-child {
    @apply mt-0
}

.md>* p:last-child {
    @apply mb-0
}


.md>* table {
    @apply my-4
}

.md>* thead {
    @apply max-w-full border-b border-b-black
}

.md>* th {
    @apply max-w-full
}

.md>* th, .md>* td {
    @apply px-2 text-left
}

.md>* tbody>tr:nth-child(even) {
    @apply bg-gray-300
}

.md>* a {
    @apply text-blue-900
}

.md>* a:hover {
    @apply text-blue-950
}

/* FIXME: */
.md>* .katex-html{
    @apply inline-flex flex-wrap text-balance break-words text-sm italic
}

.print>* .katex-html {
    @apply text-center
}
</style>
